# TODO:
# - add -n mod_wsgi-express package
#   https://github.com/GrahamDumpleton/mod_wsgi#installation-into-python

#
# Conditional build:
%bcond_without	python2 # mod_wsgi for CPython 2.x
%bcond_without	python3 # mod_wsgi for CPython 3.x

%define		mod_name	wsgi
%define		apxs		/usr/sbin/apxs
Summary:	WSGI interface for the Apache Web server
Summary(pl.UTF-8):	Interfejs WSGI dla serwera WWW Apache
Name:		apache-mod_%{mod_name}
Version:	4.5.7
Release:	4
License:	Apache
Group:		Networking/Daemons
Source0:	https://github.com/GrahamDumpleton/mod_wsgi/archive/%{version}/mod_%{mod_name}-%{version}.tar.gz
# Source0-md5:	6d307e246684399c5dc501350e34e390
Source1:	%{name}.conf
URL:		http://www.modwsgi.org/
BuildRequires:	%{apxs}
BuildRequires:	apache-devel >= 2.0.52-7
BuildRequires:	apr-devel >= 1:1.0.0
BuildRequires:	autoconf
BuildRequires:	automake
%if %{with python2}
BuildRequires:	python-devel >= 2.3
%endif
%if %{with python3}
BuildRequires:	python3-devel
%endif
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_pkglibdir	%(%{apxs} -q LIBEXECDIR 2>/dev/null)
%define		_sysconfdir	%(%{apxs} -q SYSCONFDIR 2>/dev/null)/conf.d

%description
The mod_wsgi adapter is an Apache module that provides a WSGI
compliant interface for hosting Python based web applications within
Apache. The adapter is written completely in C code against the Apache
C runtime and for hosting WSGI applications within Apache has a lower
overhead than using existing WSGI adapters for mod_python or CGI.

%description -l pl.UTF-8
Adapter mod_wsgi jest modułem udostępniającym interfejs WSGI dla
aplikacji WWW napisanych w języku Python i osadzonych w serwerze
Apache. Adapter jest w całości napisany w języku C w oparciu o
bibliotekę uruchomieniową Apache i ma mniejsze wymagania niż w
przypadku używania istniejących adapterów WSGI dla modułu mod_python
lub CGI.

%package py2
Summary:	WSGI interface for the Apache Web server
Summary(pl.UTF-8):	Interfejs WSGI dla serwera WWW Apache
Group:		Networking/Daemons
Requires:	apache(modules-api) = %{apache_modules_api}
Requires:	apr >= 1:1.0.0
Requires:	python-modules
Provides:	apache(mod_wsgi) = %{version}-%{release}
Obsoletes:	apache-mod_wsgi < 4.5.7-0.2
Conflicts:	%{name}-py3
# http://helpful.knobs-dials.com/index.php/Mod_wsgi_notes#PyEval_AcquireThread:_non-NULL_old_thread_state
Conflicts:	apache-mod_python

%description py2
The mod_wsgi adapter is an Apache module that provides a WSGI
compliant interface for hosting Python based web applications within
Apache. The adapter is written completely in C code against the Apache
C runtime and for hosting WSGI applications within Apache has a lower
overhead than using existing WSGI adapters for mod_python or CGI.

%description py2 -l pl.UTF-8
Adapter mod_wsgi jest modułem udostępniającym interfejs WSGI dla
aplikacji WWW napisanych w języku Python i osadzonych w serwerze
Apache. Adapter jest w całości napisany w języku C w oparciu o
bibliotekę uruchomieniową Apache i ma mniejsze wymagania niż w
przypadku używania istniejących adapterów WSGI dla modułu mod_python
lub CGI.

%package py3
Summary:	WSGI interface for the Apache Web server
Summary(pl.UTF-8):	Interfejs WSGI dla serwera WWW Apache
Group:		Networking/Daemons
Requires:	apache(modules-api) = %{apache_modules_api}
Requires:	apr >= 1:1.0.0
Requires:	python3-modules
Provides:	apache(mod_wsgi) = %{version}-%{release}
Conflicts:	%{name} < 4.5.7-0.2
Conflicts:	%{name}-py2
# http://helpful.knobs-dials.com/index.php/Mod_wsgi_notes#PyEval_AcquireThread:_non-NULL_old_thread_state
Conflicts:	apache-mod_python3

%description py3
The mod_wsgi adapter is an Apache module that provides a WSGI
compliant interface for hosting Python based web applications within
Apache. The adapter is written completely in C code against the Apache
C runtime and for hosting WSGI applications within Apache has a lower
overhead than using existing WSGI adapters for mod_python or CGI.

%description py3 -l pl.UTF-8
Adapter mod_wsgi jest modułem udostępniającym interfejs WSGI dla
aplikacji WWW napisanych w języku Python i osadzonych w serwerze
Apache. Adapter jest w całości napisany w języku C w oparciu o
bibliotekę uruchomieniową Apache i ma mniejsze wymagania niż w
przypadku używania istniejących adapterów WSGI dla modułu mod_python
lub CGI.

%prep
%setup -q -n mod_%{mod_name}-%{version}

%build
%{__aclocal}
%{__autoconf}

# doesn't support out of tree builds, so we just build twice
%if %{with python2}
%configure \
	--with-python=%{__python} \
	--with-apxs=%{apxs}
%{__make}
%{__make} install DESTDIR=$(pwd)/py2
%{__make} clean
%endif

%if %{with python3}
%configure \
	--with-python=%{__python3} \
	--with-apxs=%{apxs}
%{__make}
%{__make} install DESTDIR=$(pwd)/py3
%{__make} clean
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_pkglibdir},%{_sysconfdir}}
%if %{with python2}
cp -a py2/* $RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT%{_pkglibdir}/mod_%{mod_name}{,-py2}.so
sed -e 's/mod_wsgi.so/mod_wsgi-py2.so/' %{SOURCE1} > $RPM_BUILD_ROOT%{_sysconfdir}/61_mod_wsgi-py2.conf
%endif
%if %{with python3}
cp -a py3/* $RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT%{_pkglibdir}/mod_%{mod_name}{,-py3}.so
sed -e 's/mod_wsgi.so/mod_wsgi-py3.so/' %{SOURCE1} > $RPM_BUILD_ROOT%{_sysconfdir}/61_mod_wsgi-py3.conf
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%triggerpostun py2 -- %{name} < 4.5.7-0.2
if [ -f %{_sysconfdir}/61_mod_wsgi.conf.rpmsave ]; then
	mv %{_sysconfdir}/61_mod_wsgi-py2.conf{,.rpmnew}
	mv %{_sysconfdir}/61_mod_wsgi{.conf.rpmsave,-py2.conf}
	%{__sed} -i -e 's/mod_wsgi.so/mod_wsgi-py2.so/' $RPM_BUILD_ROOT%{_sysconfdir}/61_mod_wsgi-py2.conf
	%service -q httpd restart
fi

%post py2
%service -q httpd restart

%postun py2
if [ "$1" = "0" ]; then
	%service -q httpd restart
fi

%post py3
%service -q httpd restart

%postun py3
if [ "$1" = "0" ]; then
	%service -q httpd restart
fi

%if %{with python2}
%files py2
%defattr(644,root,root,755)
%doc README.rst CREDITS.rst
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/*_mod_%{mod_name}-py2.conf
%attr(755,root,root) %{_pkglibdir}/mod_%{mod_name}-py2.so
%endif

%if %{with python3}
%files py3
%defattr(644,root,root,755)
%doc README.rst CREDITS.rst
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/*_mod_%{mod_name}-py3.conf
%attr(755,root,root) %{_pkglibdir}/mod_%{mod_name}-py3.so
%endif
%changelog
* Sun Apr 23 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/apache-mod_wsgi.git;a=log;h=master

* Sun Apr 23 2017 Elan Ruusamäe <glen@delfi.ee> aee3997
- fix .rpmnew filename on trigger

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 3f13580
- python 3.6
- release 3 (by relup.sh)

* Fri Oct 21 2016 Jan Rękorajski <baggins@pld-linux.org> efbd6ce
- provide generic module name
- rel 2

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> a2ce93b
- rel 1

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> 7f9b772
- py2/py3 cross conflicts

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> 4e3e8b6
- add trigger to upgrade config from old package name

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> 1e85a36
- build python2/python3 versions

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> 4274ee9
- add note about mod_wsgi-express

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> b7b59c3
- use url from docs

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> e5678b6
- up to 4.5.7

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> 60ccbc7
- require python modules at runtime

* Fri Mar 20 2015 Elan Ruusamäe <glen@delfi.ee> fe4725b
- x32 rebuild
- release 2 (by relup.sh)

* Wed May 21 2014 Mateusz Korniak <matkor@pld-linux.org> 43d2bec
- Version 3.5-1. Security update (CVE-2014-0240)

* Wed Aug 07 2013 Mateusz Korniak <matkor@pld-linux.org> 21e75ee
- Release 4. Rebuild to silence apache warnings about build/runtime python versions.

* Thu Apr 25 2013 Elan Ruusamäe <glen@delfi.ee> 25f08ef
- rel 3

* Thu Apr 25 2013 Elan Ruusamäe <glen@delfi.ee> 7d47fcb
- conflict with mod_python

* Thu Apr 25 2013 Elan Ruusamäe <glen@delfi.ee> 637022b
- drop cvs leftovers

* Fri Apr 12 2013 Łukasz Kieś <kiesiu@pld-linux.org> 1d03b17
- release 2 (by relup.sh)

* Wed Feb 06 2013 Elan Ruusamäe <glen@delfi.ee> cd06f81
- up to 3.4, adds WSGIEnableSendfile and more improvements

* Wed Sep 15 2010 Mateusz Korniak <matkor@pld-linux.org> 57018de
- Version 3.3. Release 1.

